天天看点

HDU 1619 & UVA 116 Unidirectional TSP(树形dp,入门 , 数塔变形)

Unidirectional TSP

Description

HDU 1619 & UVA 116 Unidirectional TSP(树形dp,入门 , 数塔变形)

Background

Problems that require minimum paths through some domain appear in many different areas of computer science. For example, one of the constraints in VLSI routing problems is minimizing wire length. The Traveling Salesperson Problem (TSP) -- finding whether all the cities in a salesperson's route can be visited exactly once with a specified limit on travel time -- is one of the canonical examples of an NP-complete problem; solutions appear to require an inordinate amount of time to generate, but are simple to check.

This problem deals with finding a minimal path through a grid of points while traveling only from left to right.

The Problem

Given an 

HDU 1619 & UVA 116 Unidirectional TSP(树形dp,入门 , 数塔变形)

 matrix of integers, you are to write a program that computes a path of minimal weight. A path starts anywhere in column 1 (the first column) and consists of a sequence of steps terminating in column n (the last column). A step consists of traveling from column i to column i+1 in an adjacent (horizontal or diagonal) row. The first and last rows (rows 1 and m) of a matrix are considered adjacent, i.e., the matrix ``wraps'' so that it represents a horizontal cylinder. Legal steps are illustrated below.

HDU 1619 & UVA 116 Unidirectional TSP(树形dp,入门 , 数塔变形)

The weight of a path is the sum of the integers in each of the n cells of the matrix that are visited.

For example, two slightly different 

HDU 1619 & UVA 116 Unidirectional TSP(树形dp,入门 , 数塔变形)

 matrices are shown below (the only difference is the numbers in the bottom row).

HDU 1619 & UVA 116 Unidirectional TSP(树形dp,入门 , 数塔变形)

The minimal path is illustrated for each matrix. Note that the path for the matrix on the right takes advantage of the adjacency property of the first and last rows.

The Input

The input consists of a sequence of matrix specifications. Each matrix specification consists of the row and column dimensions in that order on a line followed by 

HDU 1619 & UVA 116 Unidirectional TSP(树形dp,入门 , 数塔变形)

 integers where m is the row dimension and n is the column dimension. The integers appear in the input in row major order, i.e., the first n integers constitute the first row of the matrix, the second n integers constitute the second row and so on. The integers on a line will be separated from other integers by one or more spaces. Note: integers are not restricted to being positive. There will be one or more matrix specifications in an input file. Input is terminated by end-of-file.

For each specification the number of rows will be between 1 and 10 inclusive; the number of columns will be between 1 and 100 inclusive. No path's weight will exceed integer values representable using 30 bits.

The Output

Two lines should be output for each matrix specification in the input file, the first line represents a minimal-weight path, and the second line is the cost of a minimal path. The path consists of a sequence of n integers (separated by one or more spaces) representing the rows that constitute the minimal path. If there is more than one path of minimal weight the path that is lexicographically smallest should be output.

Sample Input

5 6
3 4 1 2 8 6
6 1 8 2 7 4
5 9 3 9 9 5
8 4 1 3 2 6
3 7 2 8 6 4
5 6
3 4 1 2 8 6
6 1 8 2 7 4
5 9 3 9 9 5
8 4 1 3 2 6
3 7 2 1 2 3
2 2
9 10 9 10      

Sample Output

1 2 3 4 4 5
16
1 2 1 5 4 5
11
1 1
19      

题目:给你一个n*m的数字表格,找到一条从左到右的路径,使得上面的数字和最小。

           (每次可以从(i,j),走到(i,j+1),(i+1,j),(i-1,j)可以越界。越界的时候,从上面出来,从下面进来,从下面出来,从上面进来,就相当于这个图的上边和下边重合组成一个圆筒一样)

分析:dp,动态规划。因为要字典序最小,所以采用从右向左的方式dp;

           状态:f(i,j)表示走到(i,j)的最小和,则有转移方程:

           f(i,j)= min(f(i+1,j+1),f(i,j+1),f(i-1,j+1));

           记录路径输出即可。

   路径记录的时候可以用一个二维数组,path[ j ][ i ]   表示第 i 列的 第 j 行的元素 往后走要走到 i + 1 列的 path[ j ][ i ] 行,这样就可以保存下来路径了。

说明:逆向dp保证字典序最小(后继最小),正向能保证每点前驱最小。

附上代码:

#include <iostream>
#include <cstring>
#include <cstdio>
#include <algorithm>
#include <string>
#define INF 0x3f3f3f3f

using namespace std;

int main()
{
	int n,m;
	while(cin >> n >> m)
	{
		long long int dp[110][110];
		long long int Map[110][110];
		for(int i = 1;i <= n;i++)
		{
			for(int j = 1;j <= m;j++)
			{
				scanf("%lld",&Map[i][j]);
			}
		}
		memset(dp,0,sizeof(dp));          //  dp 数组  ,初始化为 0
		int path[110][110] = {0};           //  保存路径的数组,初始化为 0
		for(int i = m;i >= 1;i--)                    //  两层循环 , 第一层表示第几列  ,倒着往前推求最小值。类似于数塔
		{
			for(int j = 1;j <= n;j++) 
			{
				dp[j][i] = dp[j][i + 1] + Map[j][i];          //  将正后的当做最小值,然后跟下面的进行一个比较
				path[j][i] = j;                               //   记录 路径 
				if(j > 1 && dp[j - 1][i + 1] + Map[j][i] <= dp[j][i])       //  如果 j 大于 1 ,那么就可以走 j - 1 的位置,然后就判断 j - 1 的位置符合不符合,符合的话进行一个更新,因为 j - 1 比 j 小,所以 这里的判断需要加上 “ = ” 号,下面 等于 n 的时候也是同理,下面就不谢了
				{
					dp[j][i] = dp[j - 1][i + 1] + Map[j][i];
					path[j][i] = j - 1;
				}
				if(j < n && dp[j + 1][i + 1] + Map[j][i] < dp[j][i])     //  如果小于 n , 那么就可以走 j + 1 的位置,同样进行判断
				{
					dp[j][i] = dp[j + 1][i + 1] + Map[j][i];
					path[j][i] = j + 1;
				}
				if(j == 1 && dp[n][i + 1] + Map[j][i] < dp[j][i])       // 因为 1 和 n 都比较特殊,所以,再加上一个判断
				{
					dp[j][i] = dp[n][i + 1] + Map[j][i];
					path[j][i] = n;
				}
				if(j == n && dp[1][i + 1] + Map[j][i] <= dp[j][i])
				{
					dp[j][i] = dp[1][i + 1] + Map[j][i];
					path[j][i] = 1;
				}
			}
		}
		long long int ans = dp[1][1];
		int Min_i = 1;
		for(int i = 1;i <= n;i++)           // 遍历一遍,寻找出最小值
		{
			if(ans > dp[i][1])
			{
				Min_i = i;
				ans = dp[i][1];
			}
		}
		for(int i = 1;i <= m;i++)        //  根据标记的路径,依次输出路径
		{
			if(i > 1)
			cout << " ";
			cout << Min_i;
			Min_i = path[Min_i][i];    //  将下一个位置赋值给 Min_i
		}
		cout << endl;
		cout << ans << endl;
	}
	return 0;
}